#include <osdepend.h>
#include <SDL.h>
#include <SDL_audio.h>
#include <stdio.h>

void doNothing()
{
}

void osd_PlayTrack()
{
}

void osd_DiskStatus(int drive, char *s)
{
}

void osd_PlayStepper()
{
}

void osd_writeSoundStream(short sample)
{
}

void osd_ScanKbrd(byte *vzkbrd)
{
	byte k;
	extern bool g_running;
	
	SDL_Event e;
	const Uint8* g_keys = SDL_GetKeyboardState( NULL );
	SDL_PollEvent (&e);

	if (e.type == SDL_KEYDOWN || e.type == SDL_KEYUP)
	{

    k = vzkbrd[0];
	if (g_keys[SDL_SCANCODE_R]) k = (k & 0xDF);
	if (g_keys[SDL_SCANCODE_Q] ) k = (k & 0xEF);
	if (g_keys[SDL_SCANCODE_E] ) k = (k & 0xF7);
	if (g_keys[SDL_SCANCODE_W] ) k = (k & 0xFD);
	if (g_keys[SDL_SCANCODE_T] ) k = (k & 0xFE);
	vzkbrd[0] = k;


    k = vzkbrd[1];
	if (g_keys[SDL_SCANCODE_F] ) k = (k & 0xDF);
	if (g_keys[SDL_SCANCODE_A] ) k = (k & 0xEF);
	if (g_keys[SDL_SCANCODE_D] ) k = (k & 0xF7);
	if (g_keys[SDL_SCANCODE_LCTRL]) k = (k & 0xFB);	// Left Control
	if (g_keys[SDL_SCANCODE_S] ) k = (k & 0xFD);
	if (g_keys[SDL_SCANCODE_G] ) k = (k & 0xFE);
	vzkbrd[1] = k;

    k = vzkbrd[2];
	if (g_keys[SDL_SCANCODE_V] ) k = (k & 0xDF);
	if (g_keys[SDL_SCANCODE_Z] ) k = (k & 0xEF);
	if (g_keys[SDL_SCANCODE_C] ) k = (k & 0xF7);
	if (g_keys[SDL_SCANCODE_LSHIFT]) k = (k & 0xFB);	// Left Shift
	if (g_keys[SDL_SCANCODE_X] ) k = (k & 0xFD);
	if (g_keys[SDL_SCANCODE_B] ) k = (k & 0xFE);
	vzkbrd[2] = k;

    k = vzkbrd[3];
	if (g_keys[SDL_SCANCODE_4] ) k = (k & 0xDF);
	if (g_keys[SDL_SCANCODE_1] ) k = (k & 0xEF);
	if (g_keys[SDL_SCANCODE_3] ) k = (k & 0xF7);
	if (g_keys[SDL_SCANCODE_2] ) k = (k & 0xFD);
	if (g_keys[SDL_SCANCODE_5] ) k = (k & 0xFE);
	vzkbrd[3] = k;

    k = vzkbrd[4];
	if (g_keys[SDL_SCANCODE_M] ) k = (k & 0xDF);
	if (g_keys[SDL_SCANCODE_SPACE] ) k = (k & 0xEF);
	if (g_keys[SDL_SCANCODE_COMMA] ) k = (k & 0xF7);
	if (g_keys[SDL_SCANCODE_PERIOD]  ) k = (k & 0xFD);
	if (g_keys[SDL_SCANCODE_N] ) k = (k & 0xFE);
	vzkbrd[4] = k;

    k = vzkbrd[5];
	if (g_keys[SDL_SCANCODE_7] ) k = (k & 0xDF);
	if (g_keys[SDL_SCANCODE_0] ) k = (k & 0xEF);
	if (g_keys[SDL_SCANCODE_8] ) k = (k & 0xF7);
	if (g_keys[SDL_SCANCODE_MINUS] ) k = (k & 0xFB);
	if (g_keys[SDL_SCANCODE_9] ) k = (k & 0xFD);
	if (g_keys[SDL_SCANCODE_6] ) k = (k & 0xFE);
	vzkbrd[5] = k;

    k = vzkbrd[6];
	if (g_keys[SDL_SCANCODE_U] ) k = (k & 0xDF); else k = (k | 0x20);
	if (g_keys[SDL_SCANCODE_P] ) k = (k & 0xEF); else k = (k | 0x10);
	if (g_keys[SDL_SCANCODE_I] ) k = (k & 0xF7); else k = (k | 0x08);
	if (g_keys[SDL_SCANCODE_RETURN] ) k = (k & 0xFB); else k = (k | 0x04);
	if (g_keys[SDL_SCANCODE_O] ) k = (k & 0xFD); else k = (k | 0x02);
	if (g_keys[SDL_SCANCODE_Y] ) k = (k & 0xFE); else k = (k | 0x01);
	vzkbrd[6] = k;

    k = vzkbrd[7];
	if (g_keys[SDL_SCANCODE_J] ) k = (k & 0xDF);
	if (g_keys[SDL_SCANCODE_SEMICOLON] ) k = (k & 0xEF);
	if (g_keys[SDL_SCANCODE_K] ) k = (k & 0xF7);
	if (g_keys[SDL_SCANCODE_APOSTROPHE ] ) k = (k & 0xFB);
	if (g_keys[SDL_SCANCODE_L] ) k = (k & 0xFD);
	if (g_keys[SDL_SCANCODE_H] ) k = (k & 0xFE);
	vzkbrd[7] = k;

   // extra keys

   if ((g_keys[ SDL_SCANCODE_LEFT]) || (g_keys[ SDL_SCANCODE_BACKSPACE])) 
   {
	vzkbrd[4] &= 0xDF;              // press M
	vzkbrd[1] &= 0xFB;          // press ctrl
   }

   if (g_keys[ SDL_SCANCODE_RIGHT])     
   {
	   vzkbrd[4] &= 0xF7;              // press comma
	   vzkbrd[1] &= 0xFB;          // press ctrl
   }

   if (g_keys[ SDL_SCANCODE_UP])        
   {
	   vzkbrd[4] &= 0xFD;              // press period
	   vzkbrd[1] &= 0xFB;          // press ctrl
   }

   if (g_keys[ SDL_SCANCODE_DOWN])      
   {
	   vzkbrd[4] &= 0xEF;              // press space
	   vzkbrd[1] &= 0xFB;          // press ctrl
   }

   if (g_keys[ SDL_SCANCODE_INSERT])    
   {
	   vzkbrd[7] &= 0xFD;              // press L
	   vzkbrd[1] &= 0xFB;          // press ctrl
   }

   if (g_keys[ SDL_SCANCODE_DELETE])       
   {
	vzkbrd[7] &= 0xEF;              // press semicolon
	vzkbrd[1] &= 0xFB;          // press ctrl
   }

   if (g_keys[ SDL_SCANCODE_END] )       
   {
	vzkbrd[7] &= 0xFB;              // press apostrophe
	vzkbrd[1] &= 0xFB;          // press ctrl
   }

   //
   // Esc to exit emulation
   //
   if (g_keys[ SDL_SCANCODE_ESCAPE]) g_running = 0;

   //
   // F10 key for debug menu
   //
   //if (g_keys[ SDL_SCANCODE_F10]) debug = 1;
	}
}

void osd_BlitBuffer(byte *Buffer)
{
	byte	colorIndex;
	Uint32	screen[76800];					// device independent 320*240 back buffer for 32 bit pixels
	long	offset;
	extern	Uint32 palette[];
	extern	SDL_Renderer 	*sdlRenderer;
	extern	SDL_Texture  	*sdlTexture;


	for (int y=0; y<240; y++)
	{
		for (int x=0;x<320;x++)
		{
			offset = 320*y+x;
			colorIndex =  Buffer[offset];
			screen[offset] = palette[colorIndex];
		}
	}

	SDL_UpdateTexture(sdlTexture, NULL, screen, 320 * sizeof (Uint32));
	SDL_RenderCopy(sdlRenderer, sdlTexture, NULL, NULL);
	SDL_RenderPresent(sdlRenderer);
}

void osd_synchSound()
{
}

bool osd_SynchVZ()
{
	return true;
}

void osd_InitTimer()
{
}
